function init()
	RegisterTool("forcegun", "Forcegun", "MOD/vox/Forcegun.vox")
	SetBool("game.tool.forcegun.enabled", true)
	SetInt("game.tool.vacuum.ammo", 100)
	snd = LoadLoop("vacuum.ogg")
	
	strength = GetFloat("savegame.mod.strength")
	if strength == 0 then strength = 1.25 end
	maxMass = GetFloat("savegame.mod.maxMass")
	if maxMass == 0 then maxMass = 300 end
	maxDist = GetFloat("savegame.mod.maxDist")
	if maxDist == 0 then maxDist = 10 end
	terminal = GetFloat("savegame.mod.terminal")
	if terminal == 0 then terminal = 50 end
	FGangle = 0
	FGangVel = 0
	FGcoolDown = 0
	FGdirect = 0
	
	ready = 0
end
function draw()
	if GetString("game.player.tool") == "forcegun" and GetPlayerVehicle() == 0 then
		UiPush()
			UiTranslate(UiCenter(), UiHeight()-60)
			UiAlign("center middle")
			UiColor(1, 1, 1)
			UiFont("bold.ttf", 32)
			UiTextOutline(0,0,0,1,0.1)
			if deltTrue then
				UiColor(1, 0, 0)
				UiText("Vacuum will delete items")
			else
				UiColor(0, 1, 0)
				UiText("Vacuum won't delete items")
			end
		UiPop()
	end
end
function tick(dt)
	--Only active when holding the forcegun
	if GetString("game.player.tool") == "forcegun" then
		local tV = Transform()
		tV.pos = Vec(0.3, -0.7, 0)
		SetToolTransform(tV)
	
		--Check if blower mode is firing
		if GetBool("game.player.canusetool") and InputDown("lmb") then

			--Get all physical and dynamic bodies in front of camera
			local t = GetCameraTransform()
			local c = TransformToParentPoint(t, Vec(0, 0, -maxDist/2))
			local mi = VecAdd(c, Vec(-maxDist/2, -maxDist/2, -maxDist/2))
			local ma = VecAdd(c, Vec(maxDist/2, maxDist/2, maxDist/2))
			QueryRequire("physical dynamic")
			local bodies = QueryAabbBodies(mi, ma)
			FGangVel = math.min(1000, FGangVel + dt*5000)	
			FGdirect = true
			--Loop through bodies and push them
			for i=1,#bodies do
				local b = bodies[i]

				--Compute body center point and distance
				local bmi, bma = GetBodyBounds(b)
				local bc = VecLerp(bmi, bma, 0.5)
				local dir = VecSub(bc, t.pos)
				local dist = VecLength(dir)
				dir = VecScale(dir, 1.0/dist)

				--Get body mass
				local mass = GetBodyMass(b)
				
				--Check if body is should be affected
				if dist < maxDist then
					--Make sure direction is always pointing slightly upwards
					dir[2] = 0.5
					dir = VecNormalize(dir)
			
					--Compute how much velocity to add
					local massScale = 5 - math.min(mass/maxMass, 1.0)
					local distScale = 1 - math.min(dist/maxDist, 1.0)
					local add = VecScale(dir, strength * massScale * distScale)
					
					--Add velocity to body
					local vel = GetBodyVelocity(b)
					vel = VecAdd(vel, add)
					SetBodyVelocity(b, vel)
				end
			end

			--Play sound effect
			PlayLoop(snd, t.pos, 0.5)
		else FGangVel = math.max(100, FGangVel - dt*300)
		end

	    if InputPressed("C") then deltTrue = not deltTrue end
	
		--Check if vacuum mode is firing
		if GetBool("game.player.canusetool") and InputDown("rmb") then

			--Get all physical and dynamic bodies in front of camera
			local t = GetCameraTransform()
			local c = TransformToParentPoint(t, Vec(0, 0, -maxDist/2))
			local mi = VecAdd(c, Vec(-maxDist/2, -maxDist/2, -maxDist/2))
			local ma = VecAdd(c, Vec(maxDist/2, maxDist/2, maxDist/2))
			QueryRequire("physical dynamic")
			local bodies = QueryAabbBodies(mi, ma)
			FGangVel = math.min(1000, FGangVel + dt*5000)
			FGdirect = false
			--Loop through bodies and push them
			for i=1,#bodies do
				local b = bodies[i]

				--Compute body center point and distance
				local bmi, bma = GetBodyBounds(b)
				local bc = VecLerp(bmi, bma, 0.5)
				local dir = VecSub(bc, t.pos)
				local dist = VecLength(dir)
				adjustedStrength = strength^2
				acc = adjustedStrength*(dist - maxDist)
				dir = VecScale(dir, acc)

				--Get body mass
				local mass = GetBodyMass(b)
				adjustedMaxMass = maxMass^3
				
				if deltTrue then
					--delete when in range when enabled
					if mass < adjustedMaxMass then
						if dist < 4 then
							Delete(b)
						end

						if dist < maxDist then
							--Compute how much velocity to add
							local add = VecScale(dir, 1/dist)
							
							--Add velocity to body
							local vel = GetBodyVelocity(b)
							vel = VecAdd(vel, add)
							speed = VecLength(vel)
							maxspeed = terminal
							if speed > maxspeed then
								speedscale = maxspeed/speed
								vel = VecScale(vel, speedscale)
							end
							SetBodyVelocity(b, vel)
						end
					end
				else
					--Check if body is should be affected
					if dist < maxDist then
						--Make sure direction is always pointing slightly upwards
						dir[2] = 0.5
						dir = VecNormalize(dir)
				
						--Compute how much velocity to add
						local massScale = 5 - math.min(mass/maxMass, 1.0)
						local distScale = 1 - math.min(dist/maxDist, 1.0)
						local add = VecScale(dir, strength * massScale * distScale)
						
						--Add velocity to body
						local vel = GetBodyVelocity(b)
						vel = VecAdd(vel, add)
						speed = VecLength(vel)
						maxspeed = terminal
							if speed > maxspeed then
								speedscale = maxspeed/speed
								vel = VecScale(vel, speedscale)
							end
						SetBodyVelocity(b, vel)
					end
				end
			end
						--Play sound effect
			PlayLoop(snd, t.pos, 0.5)
			else FGangVel = math.max(0, FGangVel - dt*300)
			
			end
			FGcoolDown = FGcoolDown - dt
			if FGdirect then
			FGangle = FGangle + FGangVel*dt
			else
			FGangle = FGangle - FGangVel*dt
			end
				--Animate barrel around the attachment point
		local bv = GetToolBody()
		local voxSize = 0.05
		local attach = Transform(Vec(0.5*voxSize, 4.5*voxSize, 0))
		local attach2 = Transform(Vec(0.5*voxSize, 4.5*voxSize, 0))
		if body ~= bv then
			body = bv
			-- Barrel is the second shape in vox file. Remember original position in attachment frame
			local shapes = GetBodyShapes(bv)
			barrel1 = shapes[2] 
			barrel2 = shapes[3] 
			barrel1Transform = TransformToLocalTransform(attach, GetShapeLocalTransform(barrel1))	
			barrel2Transform = TransformToLocalTransform(attach, GetShapeLocalTransform(barrel2))	
		end
		attach.rot = QuatEuler(0, 0, FGangle)
		attach2.rot = QuatEuler(0, 0, -FGangle)
		t1 = TransformToParentTransform(attach, barrel1Transform)
		SetShapeLocalTransform(barrel1, t1)
		t2 = TransformToParentTransform(attach2, barrel2Transform)
		SetShapeLocalTransform(barrel2, t2)
		end
		
	
	end
	


