function init()
	strength = GetFloat("savegame.mod.strength")
	if strength == 0 then strength = 1.25 end
	maxMass = GetFloat("savegame.mod.maxMass")
	if maxMass == 0 or maxMass == inf then maxMass = 300 end
	maxDist = GetFloat("savegame.mod.maxDist")
	if maxDist == 0 then maxDist = 10 end
	terminal = GetFloat("savegame.mod.terminal")
	if terminal == 0 then terminal = 50 end
end

function draw()
	UiTranslate(UiCenter(), 350)
	UiAlign("center middle")

	UiFont("bold.ttf", 48)
	UiText("Forcegun")
	UiFont("regular.ttf", 26)
	UiTranslate(0, 70)
	UiPush()
		UiText("strength")
		UiAlign("right")
		UiTranslate(95, 40)
		strength = optionsSlider(strength, 0, 100)
		UiTranslate(-75, 20)
		UiColor(0.2, 0.6, 1)
		UiText(strength^2)
		SetFloat("savegame.mod.strength", strength)
	UiPop()

	UiTranslate(0, 110)
		UiPush()
		UiText("Debris threshold")
		UiAlign("right")
		UiTranslate(95, 40)
		maxMass = optionsSlider(maxMass, 0, 150)
		UiTranslate(-75, 20)
		UiColor(0.2, 0.6, 1)
		UiText(maxMass^3)
		SetFloat("savegame.mod.maxMass", maxMass)
	UiPop()

	UiTranslate(0, 110)
	UiPush()
		UiText("range")
		UiAlign("right")
		UiTranslate(95, 40)
		maxDist = optionsSlider(maxDist, 0, 100)
		UiTranslate(-75, 20)
		UiColor(0.2, 0.6, 1)
		UiText(maxDist)
		SetFloat("savegame.mod.maxDist", maxDist)
	UiPop()
	UiButtonImageBox("ui/common/box-outline-6.png", 6, 6)

	UiTranslate(0, 110)
	UiPush()
		UiText("Max Speed of Debris")
		UiAlign("right")
		UiTranslate(95, 40)
		terminal = optionsSlider(terminal, 0, 100)
		UiTranslate(-75, 20)
		UiColor(0.2, 0.6, 1)
		UiText(terminal)
		SetFloat("savegame.mod.terminal", terminal)
	UiPop()

	UiTranslate(0, 120)
	if UiTextButton("Close", 80, 40) then
		Menu()
	end
end

function optionsSlider(val, min, max)
	UiColor(0.2, 0.6, 1)
	UiPush()
		UiTranslate(0, -8)
		val = (val-min) / (max-min)
		local w = 195
		UiRect(w, 3)
		UiAlign("center middle")
		UiTranslate(-195, 1)
		val = UiSlider("ui/common/dot.png", "x", val*w, 0, w) / w
		val = round((val*(max-min)+min), 2)
	UiPop()
	return val
end

function round(number, decimals)
    local power = 10^decimals
    return math.floor(number * power) / power
end